org.apache.catalina.filters

## Class WebdavFixFilter

- java.lang.Object
- - javax.servlet.GenericFilter
  - - org.apache.catalina.filters.WebdavFixFilter

All Implemented Interfaces:
  Serializable, Filter, FilterConfig

    public class WebdavFixFilter
    extends GenericFilter

Filter that attempts to force MS WebDAV clients connecting on port 80 to use a WebDAV client that actually works. Other workarounds that might help include:

- Specifying the port, even if it is port 80, when trying to connect.
- Cancelling the first authentication dialog box and then trying to reconnect.

Generally each different version of the MS client has a different set of problems.

TODO: Update this filter to recognise specific MS clients and apply the appropriate workarounds for that particular client

As a filter, this is configured in web.xml like any other Filter. You usually want to map this filter to whatever your WebDAV servlet is mapped to.

In addition to the issues fixed by this Filter, the following issues have also been observed that cannot be fixed by this filter. Where possible the filter will add an message to the logs.

XP x64 SP2 (MiniRedir Version 3790)

- Only connects to port 80
- Unknown issue means it doesn't work

See Also:
  Serialized Form

### Field Summary

Fields
`protected static StringManager` `sm`

### Constructor Summary

Constructors
Constructor and Description
`WebdavFixFilter()`

### Method Summary

All Methods Instance Methods Concrete Methods
`void` `doFilter(ServletRequest request, ServletResponse response, FilterChain chain)` Check for the broken MS WebDAV client and if detected issue a re-direct that hopefully will cause the non-broken client to be used.

### Methods inherited from class javax.servlet.GenericFilter

`getFilterConfig, getFilterName, getInitParameter, getInitParameterNames, getServletContext, init, init`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Methods inherited from interface javax.servlet.Filter

`destroy`

### Field Detail

#### sm

    protected static final StringManager sm

### Constructor Detail

#### WebdavFixFilter

    public WebdavFixFilter()

### Method Detail

#### doFilter

    public void doFilter(ServletRequest request,
                         ServletResponse response,
                         FilterChain chain)
                  throws IOException,
                         ServletException

Check for the broken MS WebDAV client and if detected issue a re-direct that hopefully will cause the non-broken client to be used.

Parameters:
  `request` - The request to process
  `response` - The response associated with the request
  `chain` - Provides access to the next filter in the chain for this filter to pass the request and response to for further processing
Throws:
  `IOException` - if an I/O error occurs during this filter's processing of the request
  `ServletException` - if the processing fails for any other reason